#ifdef G77
#include "f2c.h"

#ifndef M_PI
#  define M_PI        3.14159265358979323846	/* pi */
#endif
#define DEG_PER_RAD 180.0/M_PI 

#ifdef KR_headers
#undef abs
#include <math.h>
extern double d_cos();
double dcosd_(x) doublereal *x;
#else
#undef abs
#include <math.h>
extern double d_cos(doublereal *x);
double dcosd_(doublereal *x)
#endif
{
#if defined(_WIN32) || defined(__linux__) || defined(NEED_ACOSD)
    return d_cos(x) * DEG_PER_RAD;
#else
    return cosd(*x);
#endif
}

#else /* !G77 */
/*
 * Keep certain compilers from complaining about empty compilation units
 * Damn you AIX xlc.
 */
static int junk_d_cosd_dummy;
#endif
