C     	INCLUDE		'SHADE:HEADER.TXT/LIST'
C+++
C	SUBROUTINE	KUMAKHOV
C
C	PURPOSE		Handles the looping for the kumakhov lens.
C
C---
     	SUBROUTINE	KUMAKHOV(RAY,AP,PHASE,ICOUNT)

#if defined(unix) || HAVE_F77_CPP
c
c This causes problems with F77 drivers, since can't use -I directive.
c so I'll use the standard cpp directive instead.
c
c	INCLUDE         './../include/common.blk'
c
c
#	include		<common.blk>
#elif defined(vms)
	INCLUDE         'SHADOW$INC:COMMON.BLK/LIST'
#endif

	DIMENSION 	RAY(12,N_DIM), PHASE (3,N_DIM), AP(3,N_DIM)
	DIMENSION	BVEC(6),ROT(5),HLINE(11),PAR(8), BPAR(14,14,6)
	REAL*8  	KPHASE(3),KAP(3),KAY(12),BDL_S(3)
	REAL*8		KO_IMAGE,TEMPKO,TEMPKO2,shape(6)
	INTEGER*4 	KOCOUNT,IDEL,FBOUNCE
	CHARACTER*80 	INFILEC
C
	IF (F_INC_MNOR_ANG.EQ.1) THEN
	  OPEN(44,FILE='KOMA_ANG',STATUS='UNKNOWN')
	ENDIF

	IF (F_KOMA_BOUNCE.EQ.1) THEN
	  OPEN(41,FILE='KOMA',STATUS='UNKNOWN')
	ENDIF

D	OPEN (19,FILE='KOh',STATUS='NEW')
D	OPEN (42,FILE='KOTHE',STATUS='NEW')
D	
C

	I_KOMA = 1
	KOXX = 0
c
C F_DOT is a flag for intialize the mirror subroutine only
C 
	F_DOT=0
            CALL MIRROR1(RAY,AP,PHASE,ICOUNT)

	F_BUNDLE = 0

	 KOCOUNT = NPOINT
	 KO_IMAGE = T_IMAGE
	 T_IMAGE = 0
	 FMIRR = 9
 	 NPOINT = 1

C
C  Call koma1 to read the FILE_KOMA and to prepare the
C Wigner-Seitz cell calculation
C

	     CALL KOMA11(BVEC,ROT,HLINE,PAR,BPAR,SHAPE)

C "super-bundle" calcs.  not implemented yet.
        IF (F_BUNDLE.EQ.1) THEN
        CALL READMEX(INFILEC,IERR,RBDL_X,RBDL_Y,KIQ,WNORM)
C       type *,'KIQ RBDL WNORM',KIQ,RBDL_X,WNORM
C
C   RBDL_X: the x-width of the bundle region; RBDL_Y: the y-width of the
C   bundle region
C   WNORM: some scale which will decide the density of the tubes
C
 
        BDL_S(1) = RBDL_X
        BDL_S(2) = RBDL_Y
        BDL_S(3) = WNORM
        ENDIF
C "super-bundle" calcs.  not implemented yet.

	TEMPKO = 1.
C
C      NUM_KUM : count how many rays pass the Kumakhov lens
C      NUM_WALL: the number of rays lost between due to the 
C                wall and block space(between tube)
C

	NUM_KUM = 0
	NUM_WALL = 0

	DO 99 I =1 , KOCOUNT
	KOXX = 0
	I_KOMA = 1

	DO 199 IP = 1, 12
	
	KAY(IP) = RAY(IP,I)

199	CONTINUE
        FBOUNCE = 0

	IF (F_KOMA_BOUNCE.EQ.1) THEN
	WRITE(41,9000)(Kay(IP),IP=1,3)
9000    FORMAT(3(1x,G12.5))
	ENDIF

D	TEMPKO=KaY(7)*Kay(7)+Kay(8)*Kay(8)+Kay(9)*Kay(9)
D	TEMPKO2=Kay(7)*Kay(4)+Kay(5)*Kay(8)+Kay(9)*Kay(6)
D	WRITE(41,9000)(Kay(IP),IP=4,6)
D	WRITE(19,9001)Kay(7),Kay(8),Kay(9),TEMPKO,TEMPKO2
D9001   FORMAT(5(1x,G12.5))
	KAP(1) = AP(1,I)
	KAP(2) = AP(2,I)
	KAP(3) = AP(3,I)

	KPHASE(1) = PHASE(1,I)
	KPHASE(2) = PHASE(2,I)
	KPHASE(3) = PHASE(3,I)
C
C   Decide which Komakohv tube the incident ray hit
C

	CALL KOMA22(KAY,BVEC,ROT,HLINE,PAR,KPHASE,BDL_S,KIQ,SHAPE)
C bundle
        IF (F_BUNDLE .EQ. 1) THEN
         ZKO_LENGTH = PAR(1)
         RO_KOMA  = PAR(4)
         PCT1 = PAR(7)
         PCT2 = PAR(8)
        END IF
C bundle

	FBOUNCE = FBOUNCE +1
	
	IF (F_KOMA_BOUNCE.EQ.1) THEN
	WRITE(41,9000)(Kay(IP),IP=1,3)
	ENDIF

	TEMPKO =1.5

	IF(I_KOMA.EQ.-1)  THEN
	NUM_WALL = NUM_WALL + 1
	GOTO 77
	ENDIF

	F_POLSEL = 3

	F_DOT = 1
 88            CALL MIRROR1(KAY,KAP,KPHASE,ICOUNT)

	IF (I_KOMA.NE.-1.AND.FBOUNCE.LT.210) THEN

	 IF (KOXX.EQ.0) THEN
D 	WRITE(42,*)FBOUNCE

	FBOUNCE = FBOUNCE +1

	IF (F_KOMA_BOUNCE.EQ.1) THEN
	WRITE(41,9000)(Kay(IP),IP=1,3)
	ENDIF

D	TEMPKO=KaY(7)*Kay(7)+Kay(8)*Kay(8)+Kay(9)*Kay(9)
D	TEMPKO2=Kay(7)*Kay(4)+Kay(5)*Kay(8)+Kay(9)*Kay(6)
D	WRITE(19,9000)(Kay(IP),IP=4,6)
D	WRITE(19,9001)Kay(7),Kay(8),Kay(9),TEMPKO,TEMPKO2

		TEMPKO = 3.7

	       GOTO 88
	 ELSE

C
C The ray has passed the tube
C
         IF (F_BUNDLE.EQ.1) THEN
          KAY(1) = KAY(1) +  PCT1
          KAY(2) = KAY(2) +  PCT2
        END IF

	NUM_KUM = NUM_KUM + 1

	IF (F_KOMA_BOUNCE.EQ.1) THEN
	  WRITE(41,*)'RAY ',I,'  No. of REFLEC. ',FBOUNCE
	ENDIF

	  DO 11 J=1,12
	 
	  RAY(J,I)=KAY(J)
 11	  CONTINUE

	  TEMPKO = 2.5
	  PHASE(1,I) =KPHASE(1)
	  PHASE(2,I) =KPHASE(2)
	  PHASE(3,I) =KPHASE(3)

	  AP(1,I) = KAP(1)
	  AP(2,I) = KAP(2)
	  AP(3,I) = KAP(3)
	 
	 ENDIF

	ELSE
C
C The ray is lost during the calculation
C

 77	  DO 299 I_DEL = 1,11
	     RAY(I_DEL,I) = 0.0D0
299	  CONTINUE

	     RAY(10,I) = -1.1D6*ICOUNT
	END IF     

 99	CONTINUE

C	WRITE(42,*) 'NUM_KUM NPOINT NUM_WALL',NUM_KUM,KOCOUNT,NUM_WALL
	T_IMAGE = KO_IMAGE
	NPOINT =KOCOUNT


C	CLOSE(42)
D	CLOSE(19)

	IF (F_KOMA_BOUNCE.EQ.1) THEN
	CLOSE(41)
	ENDIF

	IF (F_INC_MNOR_ANG.EQ.1) THEN
	CLOSE(44)
	ENDIF



	RETURN
	END

 
        SUBROUTINE READMEX(INFILE,IERR,BPX,BPY,KIQ,RFAC)
 
        CHARACTER*80 INFILE
        REAl*8  TX(4),BPX,BPY,RFAC
        INTEGER*4 IQ(2),KIQ
 
        OPEN (20,FILE=INFILE,STATUS='OLD')
        
        READ(20,*) KIQ
        READ(20,*) BPX,BPY
        READ(20,*) RFAC 
 
10      CLOSE(20)
        IERR=0
 
        RETURN
 
        END
 

